/*
 * ColorSaver ARexx example
 * ColorSaver needs to be running.....
 *
 * Cycles screen through pure RED, GREEN and BLUE
 */

Options FailAt 100
Options Results

Delay = 5

if ~show(p, 'COLORSAVER.1') then
do
   Say ' '
   Say 'Please start COLORSAVER first...'
   exit
end

Say ' '
Say ' This ColorSaver ARexx example will cycle your screen through pure'
Say ' RED, GREEN and BLUE screens pausing 'delay' seconds between each,'
Say ' and then will restore your original colors.'
Say ' '
Say ' Press <RETURN> to continue '
Pull Key .

Address COLORSAVER.1 STOREPALETTE

Address COLORSAVER.1 NUMCOLORS		  /* get number of colors */
Parse VAR Result Count

 do i=0 to Count-1
  Address 'COLORSAVER.1' 'SELECT' i
  Address COLORSAVER.1 GETRGB
  Parse VAR Result Red Green Blue
  Red = 15
  Blue = 0
  Green = 0
  Address 'COLORSAVER.1' 'SETRGB Color='i', R='Red', G='Green', B='Blue
 end

Address COMMAND wait delay

 do i=0 to Count-1
  Address 'COLORSAVER.1' 'SELECT' i
  Address COLORSAVER.1 GETRGB
  Parse VAR Result Red Green Blue
  Red = 0
  Blue = 0
  Green = 15
  Address 'COLORSAVER.1' 'SETRGB Color='i', R='Red', G='Green', B='Blue
 end

Address COMMAND wait delay

 do i=0 to Count-1
  Address 'COLORSAVER.1' 'SELECT' i
  Address COLORSAVER.1 GETRGB
  Parse VAR Result Red Green Blue
  Red = 0
  Blue = 15
  Green = 0
  Address 'COLORSAVER.1' 'SETRGB Color='i', R='Red', G='Green', B='Blue
 end

Address COMMAND wait delay

Address COLORSAVER.1 CANCEL

Say ' ...All Done....'

