/*
 * common.h - global data shared by explode and config
 *
 * Bruno Costa - 30 Dec 89 - 31 Dec 89
 *
 */

/*
 *  TAG_CODE precedes TAG_ID in memory. Must not contain 0 bytes in it, and
 * should represent an invalid machine language instruction
 */
#define TAG_CODE 0xF1234AFC

/*
 *  the relation {strlen (TAG_ID) % 4 = 3} must be TRUE for proper
 * alignment.
 */
#define TAG_ID "Data is here ->"
#define TAGSIZE 16

/*
 *  Explode Window defaults
 */
#define DEFDELAY 1	/* default time delay (speed of explosion) */
#define DEFPAT 0xffff	/* default pattern for drawing outlines */

#define MAXSTEPS 30
