*
*	Zkick V3.01 -- Copyright (C) 1991 by Daniel Zenchelsky
*
*		This program may be freely copied, as long as all copyright
*		notices are left intact and unchanged.
*

	SECTION	code

	NOLIST
	INCLUDE "zkick.i"
	LIST
	
	XDEF	_KickCopy
	XDEF	loop

	XREF	_LVOSuperState
	XREF	_LVODisable
	XREF	_LVOCopyMem

	XREF	_NumBufs
	XREF	_BufSize
	XREF	_StartKick
	XREF	_EndKick
	XREF	_MemArray

	XREF Reboot
	
	XREF KickPatch

	XREF _NORESET
     XREF _PRINT
	XREF _LOADC0

_KickCopy:

	PUTMSG <'KickCopy'>	

	movea.l $4,a6
	jsr _LVODisable(a6)
	jsr _LVOSuperState(a6)


	tst.l _LOADC0
	bne.s done

	lea.l _MemArray,a2
	movea.l _StartKick,a3

loop:
	cmp.l _EndKick,a3
	bgt.s done
	move.l (a2),a0
	move.l a3,a1
	move.l _BufSize,d0
	jsr _LVOCopyMem(a6)
	add.l #4,a2
	add.l _BufSize,a3
	jmp loop

done:
	jsr KickPatch
	tst.l _NORESET
	bne.s skipreboot

	jmp Reboot

skipreboot:

	PUTMSG <'skipreboot'>

	move.l _StartKick,a0
	move.l 4(a0),a0
	jmp (a0)

	END

