; Menus & More Installation Script
; Execution from "First!.M&M"
;
; $VER: Install.bat 2.00 (17.10.94) by Axel Sodtalbers
; $LANGUAGE: english
;


.key Target/A

Failat 20

IF NOT Exists "$MMPath"
  MMReq YESNO "Create the given directory?"
  IF NOT ERROR
    MakeDir "$MMPath"
  ENDIF
ENDIF;

echo "*nCreating target directory <Target>M&M..."
Makedir "<Target>M&M"
Copy MM:Examples.info to "<Target>M&M.info" QUIET

echo "*nCopying Menus & More programs to <Target>M&M..."
Copy MM:MMEditor        to "<Target>M&M" QUIET
Copy MM:MMEditor.info   to "<Target>M&M" QUIET
Copy MM:MMPlayer        to "<Target>M&M" QUIET
Copy MM:MMPlayer.info   to "<Target>M&M" QUIET
Copy MM:MMReq           to "<Target>M&M" QUIET
Copy MM:MMReq.info      to "<Target>M&M" QUIET
Copy MM:MMAnalyse       to "<Target>M&M" QUIET
Copy MM:MMAnalyse.info  to "<Target>M&M" QUIET
Copy MM:M&M.config.info to "<Target>M&M" QUIET
Copy MM:M&M.icon.info   to "<Target>M&M" QUIET
Copy MM:First!.M&M	to "<Target>M&M" QUIET
Copy MM:First!.M&M.info to "<Target>M&M" QUIET

Copy MM:Install.bat		to "<Target>M&M" QUIET
Copy MM:Registration.bat	to "<Target>M&M" QUIET
Copy MM:Registration.txt	to "<Target>M&M" QUIET

echo "*nCopying documentation to <Target>M&M..."
Copy MM:M&M.guide#?     to "<Target>M&M" QUIET
Copy MM:M&M.guide	to "<Target>M&M/M&M.dok" QUIET ; if there is no AmigaGuide
Copy MM:ReadMe.guide#?  to "<Target>M&M" QUIET

echo "*nCopying Examples to <Target>M&M..."
Copy MM:Examples       to "<Target>M&M/Examples" ALL QUIET
Copy MM:Examples.info  to "<Target>M&M" QUIET

IF NOT Exists LIBS:asl.library
  MMReq YESNO "Copy ASL.library to LIBS: ?"
  IF NOT ERROR
    LAB WB1
    MMReq OKCANC "Please insert original WB-Disk into DF0: !"
    IF NOT ERROR
      IF NOT exists df0:libs/asl.library
        Skip WB1 BACK
      ENDIF
    ELSE
      Copy df0:libs/asl.library TO LIBS: QUIET
    ENDIF
  ELSE
    echo "*e[32m*nPlease install LIBS:asl.library later on!*e[31m"
  ENDIF
ENDIF

IF NOT Exists LIBS:diskfont.library
  MMReq YESNO "Copy diskfont.library to LIBS: ?"
  IF NOT ERROR
    LAB WB2
    MMReq OKCANC "Please insert original WB-Disk into DF0: !"
    IF NOT ERROR
      IF NOT exists df0:libs/diskfont.library
        Skip WB2 BACK
      ENDIF
    ELSE
      Copy df0:libs/diskfont.library TO LIBS: QUIET
    ENDIF
  ELSE
    echo "*e[32m*nPlease install LIBS:diskfont.library later on!*e[31m"
  ENDIF
ENDIF

IF NOT Exists LIBS:rexxsyslib.library
  MMReq YESNO "Copy rexxsyslib.library to LIBS: ?"
  IF NOT ERROR
    LAB WB3
    MMReq OKCANC "Please insert original WB-Disk into DF0: !"
    IF NOT ERROR
      IF NOT exists df0:libs/rexxsyslib.library
        Skip WB1 BACK
      ENDIF
    ELSE
      Copy df0:libs/rexxsyslib.library TO LIBS: QUIET
    ENDIF
  ELSE
    echo "*e[32m*nPlease install LIBS:rexxsyslib.library later on!*e[31m"
  ENDIF
ENDIF

MMReq YESNO "Shall AmigaGuide V34 be copied, too ?"
IF NOT ERROR
  Echo "*nCopying AmigaGuide V34 to SYS:Utilities..."
  Copy MM:AGuide/AmigaGuide         to SYS:Utilities/AmigaGuide		QUIET
  Copy MM:AGuide/AmigaGuide.info    to SYS:Utilities/AmigaGuide.info	QUIET
  Echo "*nAmigaGuide.library nach LIBS: kopieren..."
  Copy MM:AGuide/amigaguide.library to LIBS:				QUIET
ENDIF

MMReq YESNO "Is Commodore ED in the C: directory ?"
IF ERROR
  LAB WB
  MMReq OKCANC "Please insert original WB-Disk into DF0: !"
  IF NOT ERROR
    IF NOT exists df0:c/ed
      Skip WB BACK
    ELSE
      Copy df0:c/ed TO C: QUIET
    ENDIF
  ELSE
    echo "*e[32m*nPlease install C:Ed later on!*e[31m"
  ENDIF
ENDIF

MMReq YESNO "Insert Assign MM: Target into user-startup ?"
IF NOT ERROR
  copy S:User-Startup to S:User-Startup.old

  echo > T:Axel "Assign MM: *"<Target>M&M*"         ; for Menus & More"
  join T:Axel S:User-Startup TO T:Sodtalbers
  copy T:Sodtalbers to S:User-Startup QUIET
  delete T:Axel QUIET
  delete T:Sodtalbers QUIET
ELSE
  echo "*e[32m*n*nPlease type *"Assign MM: <Target>M&M*" before starting the examples!"
  echo "or insert this into the startup-sequence"
ENDIF

echo "*e[31m*n*n*nInstallation finished - close window via CTRL+\ !"
