/*
 * ColorSaver ARexx example
 * ColorSaver needs to be running.....
 *
 * Cycles through several different screen palettes, then restores the 
 * original colors...
 */

Options FailAt 100
Options Results

Delay = 3

if ~show(p, 'COLORSAVER.1') then
do
   Say ' '
   Say 'Please start COLORSAVER first...'
   exit
end

Say ' '
Say ' This ColorSaver ARexx example will cycle through several different'
Say ' palettes pausing for 'delay' seconds each, and then will restore your'
Say ' original colors.  You could of course modify it to cycle your'
Say ' screen colors at regular intervals (to keep you from getting bored!;)'
Say ' or have it called to set a specific palette when a certain event'
Say ' occurs, like "new mail", etc...'
Say ' '

Address COLORSAVER.1 STOREPALETTE

Address COLORSAVER.1 LOAD  'Elm.rgb4' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'MWB.rgb8' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Forest.rgb4' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Muave.rgb4' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Royalty.rgb8' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Ocean.rgb4' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Princess.rgb8' 
Address COMMAND wait delay

Address COLORSAVER.1 LOAD  'Smoke.rgb4' 
Address COMMAND wait delay

Address COLORSAVER.1 CANCEL

Say' ...All Done...'


