;
; $PROJECT: man.datatype
;
; $VER: classbase.i 39.1 (15.11.94)
;
; by
;
; Stefan Ruppert , Windthorststrae 5 , 65439 Flrsheim , GERMANY
;
; (C) Copyright 1994
; All Rights Reserved !
;
; $HISTORY:
;
; 15.11.94 : 039.001 :  initial
;

        IFND CLASSBASE_I
CLASSBASE_I SET 1

;-----------------------------------------------------------------------

        INCLUDE "exec/types.i"
        INCLUDE "exec/libraries.i"
        INCLUDE "exec/lists.i"
        INCLUDE "exec/semaphores.i"
        INCLUDE "utility/tagitem.i"

        INCLUDE "man_rev.i"

;-----------------------------------------------------------------------

   STRUCTURE ClassBase,LIB_SIZE
        UWORD   cb_UsageCnt
        ULONG   cb_SysBase
        ULONG   cb_DOSBase
        ULONG   cb_IntuitionBase
        ULONG   cb_GfxBase
        ULONG   cb_UtilityBase
        ULONG   cb_IFFParseBase
        ULONG   cb_DataTypesBase
        ULONG   cb_SuperClassBase
        ULONG   cb_SegList
        STRUCT  cb_Lock,SS_SIZE
        ULONG   cb_Class
   LABEL ClassBase_SIZEOF

;-----------------------------------------------------------------------
; set here some defines for the generic classinit.asm module
; Note: that define a string using a equ is only working if the string
;       is larger than 4 characters (SAS asm) ! In this case it works,
;       because of the '.datatype' suffix !

DATATYPENAME   equ 'man.datatype'
ENGINE         equ _ObtainManEngine

        XREF _ObtainManEngine

;-----------------------------------------------------------------------

        LIBINIT

        LIBDEF  _LVODispatch

;-----------------------------------------------------------------------

CALL MACRO <Function_Name>
        xref _LVO\1
        jsr _LVO\1(A6)
     ENDM

;-----------------------------------------------------------------------

GO   MACRO <Function_Name>
        xref _LVO\1
        jmp _LVO\1(A6)
     ENDM

;----------------------------------------------------------------------

        ENDC    ; CLASSBASE_I

