*
*	Zkick V3.01 -- Copyright (C) 1991 by Daniel Zenchelsky
*
*		This program may be freely copied, as long as all copyright
*		notices are left intact and unchanged.
*

	INCLUDE 'exec/execbase.i'

	XREF _ColdReboot

SetVectors:

	move.l 4,a6
	
	cmp.w #33,LIB_VERSION(a6)
	blt.s done
	cmp.w #34,LIB_VERSION(a6)
	bgt.s done
	
	tst.l MaxExtMem(a6)
	beq.s done

	move.l MaxLocMem(a6),ChipRam

	lea ColdRoutine,a0
	move.l a0,ColdCapture(a6)

; Recalculate checksum

	lea $22(a6),a0
	moveq #$16,d0
	moveq #0,d1
sumloop:
	add.w (a0)+,d1
	dbra d0,sumloop
	not.w d1
	move.w d1,$52(a6)

	jsr _ColdReboot

done:
	moveq #0,d0
	rts

ColdRoutine:

     bchg      #1,$BFE001  ; Flip the power light to bright.

	move.l #$676,A6	  ; Load ExecBase into A6
	move.l ChipRam,A3	  ; amount of chip ram
	move.l #0,A4		  ; 0K of fast ram

	jmp       $FC0240

ChipRam:	dc.l 0

		END

