**
**	stubs for the intuition functions 
**	to be SetFunction()'ed
**

	INCLUDE "exec/types.i"

	SECTION CODE

	XREF	_SysBase

	XREF    _LVOForbid
	XREF    _LVOPermit

        XREF    _CloseWindowR
	XREF    _MoveWindowR
	XREF    _OpenWindowR
	XREF    _SizeWindowR
	XREF    _WindowToBackR
	XREF    _WindowToFrontR
	XREF    _ActivateWindowR
	XREF    _MoveWindowInFrontOfR
	XREF    _ChangeWindowBoxR
	XREF    _ZipWindowR
	XREF    _OpenWindowTagListR

        XDEF    _CloseWindowStub
	XDEF    _MoveWindowStub
	XDEF    _OpenWindowStub
	XDEF    _SizeWindowStub
	XDEF    _WindowToBackStub
	XDEF    _WindowToFrontStub
	XDEF    _ActivateWindowStub
	XDEF    _MoveWindowInFrontOfStub
	XDEF    _ChangeWindowBoxStub
	XDEF    _ZipWindowStub
	XDEF    _OpenWindowTagListStub

_CloseWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_CloseWindowR
	movem.l	(sp)+,a4
	rts

_MoveWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_MoveWindowR
	movem.l	(sp)+,a4
	rts

_OpenWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_OpenWindowR
	movem.l	(sp)+,a4
	rts

_SizeWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_SizeWindowR
	movem.l	(sp)+,a4
	rts

_WindowToBackStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_WindowToBackR
	movem.l	(sp)+,a4
	rts

_WindowToFrontStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_WindowToFrontR
	movem.l	(sp)+,a4
	rts

_ActivateWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_ActivateWindowR
	movem.l	(sp)+,a4
	rts

_MoveWindowInFrontOfStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_MoveWindowInFrontOfR
	movem.l	(sp)+,a4
	rts

_ChangeWindowBoxStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_ChangeWindowBoxR
	movem.l	(sp)+,a4
	rts

_ZipWindowStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_ZipWindowR
	movem.l	(sp)+,a4
	rts

_OpenWindowTagListStub:
	movem.l	a4,-(sp)
	lea		4(sp),a4
	jsr		_OpenWindowTagListR
	movem.l	(sp)+,a4
	rts

	END
